From d237a0ad37243eb414c46cee0b2d079bc6759b5a Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 29 2016 21:00:51 +0000
Subject: [PATCH 361/1001] Get invalidation for the meetings widget working.


---

diff --git a/hubs/widgets/meetings.py b/hubs/widgets/meetings.py
index 58f36cb..87edcb8 100755
--- a/hubs/widgets/meetings.py
+++ b/hubs/widgets/meetings.py
@@ -81,20 +81,20 @@ def data(session, widget, calendar):
     return dict(meetings=meetings)
 
 
-@hint(categories=['fedocal'])
+@hint(ubiquitous=True)
 def should_invalidate(message, session, widget):
-    # first, access our *old* cache value
-    old_data = widget.module.data(session, widget, **widget.config)
-
-
-    # TODO -- we have a hard problem here.
-    # There is no event which should invalidate this widget...
-    # but we do need to expire ourselves after the date of the meeting we
-    # cached has passed.
-    # Perhaps we should expand the should_invalidate API to return a tuple:
-    #  - True/False if we should or shouldn't invalidate.
-    #  - an expiry in seconds where -1 is default and means "never expire"
-    # with that.. we could have this function return the timestamp of the
-    # meeting in seconds.. such that once it has passed, our cache will free
-    # up.
-    raise NotImplementedError()
+
+    # TODO -- first, if this is a fedocal widget, we need to just invalidate
+    # ourselves right away.
+
+    # second, check our old cache value and see if any of our meetings have
+    # passed by in time.
+    old_data = data(session, widget, **widget.config)
+    meetings = old_data['meetings']
+    now = datetime.datetime.utcnow()
+    for title, meeting in meetings.items():
+        assert type(meeting['start_dt']) == type(now)
+        if meeting['start_dt'] < now:
+            return True
+
+    return False

